#define F_CPU 16000000

void Pomiar_temperatury(void);						//menu_klaw.h
int Pomiar_temperatury2(void);						//menu_klaw.h
void delay(unsigned int msec);

#include <avr\io.h>
#include <util/delay.h>	
#include <avr/pgmspace.h>
#include "biblioteki_H\string.h"
#include "biblioteki_H\interrupt.h"  
#include "biblioteki_H\zmienne.h"
#include "biblioteki_H\pomocnicze.h"
#include "biblioteki_H\timer.h"
#include "biblioteki_H\USART2.h"
#include "biblioteki_H\podmenu.h"
#include "biblioteki_H\ustaw.h"
#include "biblioteki_H\lcd.h"
#include "biblioteki_H\RS232.h"
#include "biblioteki_H\config.h"
#include "biblioteki_H\OW_DS.h"
#include "biblioteki_H\nastawy.h"
#include "biblioteki_H\menu_klaw.h"

    
int main ()
{
	 
	
//############################################################################
//######################                      ################################
// #####################  ustawienia portw   ################################
//######################                      ################################
//############################################################################
//PORTx   	gdy jest wyjciem - okrela stan fizyczny
//			gdy jest wejciem - 1 wcza rezystory PULL-UP
//DDRx		0 wejcie
//			1 wyjcie


// Ustawienie portu A  (LCD)
	DDRA = 0xFF;								//port LCD pracuje jako wyjcie
	PORTA = 0x00;								// stna portu 0

// Ustawienie portu B  (przekanik, i SCJK)
	DDRB = DDRB |0b11111101; 					//Ustawiam wyjcia na porcie z wyjtkiem SCK na pinie 1
	PORTB = DDRB & 0b00000010;					// Stan portw w stanie niskim z wyjtkiem SCK

// Ustawienie portu C  (przetwornik Cyfra analog)
	DDRC = 0b11111111; 							// Port pracuje jako wyjcie
	PORTC = 0b00000000;							// stan niski portu

//Na porcie D s wyczeni podczone switche
	DDRD  = 0b00111111;							// porty wejciowe 6,7 pozostae wyjcia
	PORTD = 0b11000000;							// piny 6,7 rezystory podcigajce, pozostae stan niski

//Na porcie E s sygnay RX i TX na pinach 0,1 pozostae wolne
	DDRE  = DDRE | 0b11111110;	   				 // port pracuje jako wyjscie oprcz 0-rx,1-tx
	PORTE = PORTE & 0b00000001;					// stan niski na linia 7 do 2 


//Na portcie F ustawienie portu przetowrnika ADC
	DDRF 	= 0b00000000;						//port pracuje jako wejscie
	PORTF	= 0b00000000;						// bez rezystorw podcigajcych
	

//Na portcie G ustawienie portu 
	DDRG 	= 0b00000001;						
	PORTG	= 0b00000000;						
	delay(1);

//############################################################################
//########################                 ###################################
//########################  OPIS PRZERWA  ###################################
//########################                 ###################################
//############################################################################

	sei();//globalne odblokowanie przerwa

	EIMSK = 0x00;					// zablokowane przerwania od int
	TIMSK = TIMSK & 0b01011101;		// zablokowane przerwania od timerw

	init_TIMER0();					// odblokowanie i inicjalizacjia timera0
	init_USART();					//inicjalizacja moduu USART
	
//############################################################################
//############################################################################
//############################################################################
//############################################################################
	 

	

	delay(100);			// inicjalizacjaLCD 
 	LCD_init();			//

//informacja o wersji oprogramowania
	WriteTextXY(0,0,"  Charger V.1   ");	
 	WriteTextXY(0,1,"     V 2.0      ");
	delay(1500);
	WriteTextXY(0,0,"                ");	
 	WriteTextXY(0,1,"                ");

	
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
	l_menu_k=1;l_menu_wys=0xfe;							//zezwolenie na wywietlenie opisu podmenu
	flagodb = 1;komenda = 13;

	l_menu_wys_mat = 0xfe;								//zezwolenie na wywietlenie opisu podmenu LCD
	





//***********************************************************************************************
//***********************************************************************************************
//**********************************************************************************************8
//awaryjne wejcie do boot loadera
//zwarcie podczas startu pinu SWITCHA 1 powoduje przeskok do sekcji bootloadera

			ak_smiec = PIND;
			ak_smiec = ak_smiec & 0b10000000; 
	
			if(ak_smiec == 0) 
						{
						WriteTextXY(0,0,"  BOOT LOADER   ");	
 	 					WriteTextXY(0,1,"                ");
						asm("jmp 0xf000"); 
						};	

//***********************************************************************************************
//***********************************************************************************************
//***********************************************************************************************

zmienne_eeprom();			//ustaw.h


//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
// Odczyt resetw


WriteTextXY(0,0,"Licznik         ");	
WriteTextXY(0,1,"uruchomienia    ");
GotoXY(13,1);
binbcd2 (errory);
LcdWrite(v3);LcdWrite(v4);LcdWrite(v5);
delay(1000);
WriteTextXY(0,0,"                ");	
WriteTextXY(0,1,"                ");



//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//$$$$$$$$$$$$$$$$$                      $$$$$$$$$$$$$$$$$$$$$
//$$$$$$$$$$$$$$$$$   PROGRAM GWNY     $$$$$$$$$$$$$$$$$$$$$
//$$$$$$$$$$$$$$$$$                      $$$$$$$$$$$$$$$$$$$$$
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
while(1)  // PROGRAM GWNY
 	{
 	delay(5);
	komunikacja_PC();							//rs232.h
	wybor();									//rs232.h
	nadaj_param();   							//rs232.h
	if(WYB_menu_nastaw==0)	menu_klaw_mat();	//menu_klaw.h
	odczyt_klaw ();								//pomocnicze.h
	if(WYB_menu_nastaw==0) zadania_klaw ();		//menu_klaw.h
	czasomierz ();								//timer.h
	nast();										//nastawy.h
	wybor();
	termostat();								//pomocnicze.h
	zapis_eeprom ();							//pomocnicze.h
	};
};















