/*
PROCEDURY potrzebne do alarmowania 
Radosaw Rochowski 03.04.2009


*/

int autryzacja(char access_kod);
void alarm (char alarma);
int alarmowanie_a(unsigned char telefon,unsigned char access_kod);
void pik (char pik1);
void uzbrojenie(void);
void czujka(void);
void abwera(void);
void opis_alarmu(char alarma);
void drzwi(void);

// RETURN opuszczenie procedury spowodowane:
//	1	Procedura przebiega poprawnie
// 	2   przekroczeniem czasu poprawnego sygnau inii telefonicznej
//	3	przekroczenie czasu odebrania telefonu
//	4   bdna autoryzacja uytkownika przed nadaniem kodu alarmu
//	5	bldna autoryzacja uytkownika po nadaniu kodu alarmu
//	6	brak numeru telefonu pod wskazanym adresem EEPROM

int alarmowanie_a(unsigned char telefon,unsigned char access_kod)
	{
		// Sprawdzenie czy istnieje numer telefonu pod podanym adresem eeprom
		if(EEPROM_read(telefon)=='\0') return(6);
			
		ink = 1;						//zerowanie licznika opuszczenia ptli(przekroczenia czasu)		

		start_alarmowanie:
		dane=zgloszenie();				//Sprawdzenie sygnau linii telefonicznej

		if(dane == 1)
			 	{
				WriteTextXY(0,0,"  S Y G N A L   ");	
 	 			WriteTextXY(0,1,"   Gotowosci    ");
				}
		else 	
			 {
			 WriteTextXY(0,0,"  Brak sygnalu  ");	
 	 		 WriteTextXY(0,1,"   Gotowosci    ");					
			 
			 
		     DDRB = 0b01100000;
		     PORTB = PORTB | 0b01000000;
			 delay(3000);				//Czekam 3 sek poniewa linia telefoniczna jest nie aktywna
			 
			 if(ink == 3) return(2);	// przekroczenie czasu poprawnego sygnau linii telefonicznej
			 ink++;	
			
			 goto start_alarmowanie;		
						
			 };	
			 
	
//**********************************************8
//**********************************************

		//dalsza czc programu alrmowania sygna gotowoci
		
		DebugSendString_P(PSTR("Wybieram numer telefonu")); nadaj(10); nadaj(13);
				
		epadr = telefon;										//miejsce w EEPROM
		WriteTextXY(0,1,"                ");
		GotoXY(0,1);
			
		for (R16g=0; R16g<=15; R16g++)
			{
			if(EEPROM_read(epadr)=='\0') goto swese22;
			nadaj(EEPROM_read(epadr));
			
			LcdWrite(EEPROM_read(epadr));
			
			if((EEPROM_read(epadr)-48) == 0)			//nadawanie sygnau zera
				{
				nadajDTMF(10);
				goto jkla;
				}
			
			nadajDTMF(EEPROM_read(epadr)-48);
		
		jkla:	
			delay(250);
	
			SET_RS0_MT;			//Przerwa w nadawaniu sygnau	
			WRR(0b00000100);	//ustawienia rejestrw	
			CLR_RS0_MT;
			delay(100);
				

			epadr++;
			};
		
		swese22:		
		
		SET_RS0_MT;			//Wyczenie DTMF	
		WRR(0b00000100);	//ustawienia rejestrw	
		CLR_RS0_MT;				nadaj(10);nadaj(13);

		//Wybrano numer telefonu nr 1
//**********************************************
//**********************************************
//**********************************************
		// sprawdzaenie odebrania telefonu
		

		czas_wyj = 0;				//zerowanie licznika opuszczenia ptli(przekroczenia czasu)	
									// licznik zwikszany automatycznie w przerwaniu 20 ms
										
		
		sdf54:
		dane=zgloszenie();				//Sprawdzenie sygnau linii telefonicznej

		if(dane == 5)
			 	{
				WriteTextXY(0,0," Nawiazano      ");	
 	 			WriteTextXY(0,1," polaczenie     ");
				}
		else 	
			 {
			 
			 if (czas_wyj >= 1250) 
			 	{
				DDRB = 0b01100000;
		    	PORTB = PORTB | 0b01000000;
				return(3);	
				};
			 goto sdf54;		
			 };	

		//dalsza cz alarmowania autoryzacja uytkownika
//**********************************************
//**********************************************
//**********************************************		
		delay(50);
		nadajDTMF(0);
		delay(500);

		SET_RS0_MT;			//Przerwa w nadawaniu sygnau	
		WRR(0b00000100);	//ustawienia rejestrw	
		CLR_RS0_MT;
		delay(500);
		
		nadajDTMF(0);
		delay(500);

		SET_RS0_MT;			//Przerwa w nadawaniu sygnau	
		WRR(0b00000100);	//ustawienia rejestrw	
		CLR_RS0_MT;
		delay(50);

		// pobranie kodu autoryzacji.
//**********************************************
//**********************************************
//**********************************************
		if(autryzacja(access_kod)==1)return(4);
		delay(1000);

// rozpoznanie kodu alarmu oraz nadanie sygnau dzwikowego
			alarm (alarma);
			delay(1000);
// potwierdzenie odbioru alarmu
		if(autryzacja(access_kod)==1)return(5);

//**********************************************8
//**********************************************		
// PROCEDURA PRZEBIEGA POPRAWNIE
//KONIEC PROCEDURY

	DebugSendString_P(PSTR("Przek lin OFF")); nadaj(10); nadaj(13);
   	DDRB = 0b01100000;
   	PORTB = PORTB | 0b01000000;
	return(1);
	};






//**********************************************8
//**********************************************
//**********************************************
//**********************************************
//**********************************************

void alarm (char alarma)
	{	// rozpoznanie kodu alarmu orz nadani sygnau dzwikowego


			WriteTextXY(0,0,"   A L A R M    ");
			ak_smiec = alarma;							//rozpoznanie alarmu
			
			ak_smiec = ak_smiec & 0b00000001; 
			if (ak_smiec == 0) 
				{
				//Alarm1
				pik (1);
				delay(1000);

				}; 	
			ak_smiec = alarma;
			ak_smiec = ak_smiec & 0b00000010; 
			if (ak_smiec == 0) 
				{
				//Alarm2
				pik (2);
				delay(1000);
				}; 	
			ak_smiec = alarma;
			ak_smiec = ak_smiec & 0b00000100; 
			if (ak_smiec == 0) 
				{
				//Alarm3
				pik (3);
				delay(1000);
				};
			ak_smiec = alarma;
			ak_smiec = ak_smiec & 0b00001000; 
			if (ak_smiec == 0) 
				{
				//Alarm4
				pik (4);
				delay(1000);
				};
			ak_smiec = alarma;
			ak_smiec = ak_smiec & 0b00010000; 
			if (ak_smiec == 0) 
				{
				//Alarm5
				pik (5);
				delay(1000);
				};		
			ak_smiec = alarma;
			ak_smiec = ak_smiec & 0b00100000; 
			if (ak_smiec == 0) 
				{
				//Alarm6
				pik (6);
				delay(1000);
				};
			ak_smiec = alarma;
			ak_smiec = ak_smiec & 0b01000000; 
			if (ak_smiec == 0) 
				{
				//Alarm7
				pik (7);
				delay(1000);
				};
			ak_smiec = alarma;
			ak_smiec = ak_smiec & 0b10000000; 
			if (ak_smiec == 0) 
				{
				//Alarm8
				pik (8);
				delay(1000);
				};
				
			dane = PINC;
			dane = dane & 0b00000001;
			if (dane != 0b00000001)
				{
				//alarm od zasilania
				pik (9);
				delay(1000);
				};
					

	return;
	};

//**********************************************8
//**********************************************
//**********************************************
//**********************************************
//**********************************************
void pik (char pik1)
	{
	nadajDTMF(0);
	delay(1000);
	SET_RS0_MT;			//Przerwa w nadawaniu sygnau	
	WRR(0b00000100);	//ustawienia rejestrw	
	CLR_RS0_MT;
	delay(500);	

	for (pik2=0;pik2!=pik1;pik2++)
		{
		nadajDTMF(0);
		delay(200);

		SET_RS0_MT;			//Przerwa w nadawaniu sygnau	
		WRR(0b00000100);	//ustawienia rejestrw	
		CLR_RS0_MT;
		delay(300);

		};
	return;
	};

//**********************************************
//**********************************************
//**********************************************

int autryzacja(char access_kod)
	{
	czas_wyj = 0;				//zerowanie licznika opuszczenia ptli(przekroczenia czasu)	
								// licznik zwikszany automatycznie w przerwaniu 20 ms
	k=1;
	while(k!=5)
		{
		

		klqa1:
			if(	czas_wyj >= 500)
				{
				DDRB = 0b01100000;
		    	PORTB = PORTB | 0b01000000;

				error_code=1;	// nie waciwy kod autoryzacji
				WriteTextXY(0,0,"  Niewlasciwy   ");	
 	 			WriteTextXY(0,1," kod autoryzacji");
				return (error_code);
				};
			
			CLR_RS0_MT		// zapis odczyt Rejestru Danych MT8888
			delay(5);
			ak_smiec=RDD();
			if (ak_smiec != 0)
				{
				
				dane2=ak_smiec;
				nadajDTMF(0);
				delay(25);
				SET_RS0_MT;
				WRR(0b00000100);	//ustawienia rejestrw do wyczenia DTMF	
				CLR_RS0_MT;
				delay(5);
			
				ak_smiec=RDD();
				if (ak_smiec != 0)goto klqa1;

			
				if(dane2 == 10) dane2 = 0;
		
				aut_kod[k]=dane2;
			
				k++;
				czas_wyj = 0;				//zerowanie licznika opuszczenia ptli(przekroczenia czasu)	
											// licznik zwikszany automatycznie w przerwaniu 20 ms
					
				};
		};

		// porwnanie kodu autoryzacji 
		// wprowadzenie danych

		
			epadr = access_kod;							//miejsce w EEPROM
			
			for (R16g=0; R16g<=4; R16g++)
			{
			if(EEPROM_read(epadr)=='\0') goto swea1;
			kod_access[R16g]=EEPROM_read(epadr);
			epadr++;
			};
			swea1:	
	
	
		// porwnanie kodu autoryzacji z tablic podstawow
			for (R16g=0; R16g<=3; R16g++)
			{
			
			

			if(kod_access[R16g]!=aut_kod[R16g+1]+48) 
				{
				DebugSendString_P(PSTR("Przek lin OFF")); nadaj(10); nadaj(13);
		    	DDRB = 0b01100000;
		    	PORTB = PORTB | 0b01000000;

				error_code=1;	// nie waciwy kod autoryzacji
				WriteTextXY(0,0,"  Niewlasciwy   ");	
 	 			WriteTextXY(0,1," kod autoryzacji");
				return (error_code);
				};
			};

			
 	 		WriteTextXY(0,0,"  Z G O D N Y   ");
			WriteTextXY(0,1," Kod autoryzacji");

	return(error_code=0);
	};
//**********************************************8
//**********************************************
//**********************************************
//**********************************************
//**********************************************



void uzbrojenie(void)
	{
		

	ak_smiec = PINE;
	ak_smiec = ak_smiec & 0b01000000; 
	
	if(ak_smiec != 0b01000000)	
		{
		for(R16g=0;R16g <= 20;R16g++)
			{
			delay(100);
			
			ak_smiec = PINE;
			ak_smiec = ak_smiec & 0b01000000; 
	
			if(ak_smiec == 0b01000000) return;	
			};
		
		alarm_akt= !alarm_akt;

		if(	alarm_akt == 1) 
				
				{
				if_ok = PINF;				// kawaek programu odpowedzialny za blokade odpalenia alarmu
				if_ok = if_ok & 0b11111110;	// jezeli czujniki sa aktywne
				dane = PINC;
				dane = dane & 0b00000001;
				
				if((if_ok != 0b11111110) || (dane != 0b00000001))
					{
					if_ok = if_ok | 0b00000001;
		 	 		WriteTextXY(0,0,"Najpierw wylacz ");
					WriteTextXY(0,1,"    czujniki    ");
					delay(2000);
					WriteTextXY(0,0,"Alarmy aktywne: ");	
 	 				WriteTextXY(0,1,"                ");
					opis_alarmu(if_ok);
					
					
					alarm_akt = 0;
					return;
					}; 
			
			
				alarmowanie();
				};
		
		if( alarm_akt == 0) 
			{

			WriteTextXY(0,0,"   CENTRALA     ");	
 	 		WriteTextXY(0,1,"   ALARMOWA     ");
			
			scvf:

			ak_smiec = PINE;
			ak_smiec = ak_smiec & 0b01000000; 
	
			if(ak_smiec == 0) goto scvf; 
			};
		};

	return;
	}


//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$44
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$44

void czujka(void)
	{
//	alarma= 0b00100100;	// rodzaj alarmu
//alarm_ok=1;  		// uruchomienie alarmu w celach testowych
//		alarma= 0b00100100;	// rodzaj alarmu

	if(alarm_akt==1)		// gdy jest uzbrojony alarm
		{
		

		
		alarma = PINF;
		dane = PINC;
		dane = dane & 0b00000001;
		
		
		if((alarma !=0xff) || (dane != 0b00000001))		// wystpienie jakiego alarmu
			{
			delay(2000);
			if (PINF == 0xff)	
				{
				
			
				drzwi();		// sprawdzenie drzwi wejciowych
				if (end_awaryjny==0)
						{
							end_awaryjny=1;
							alarm_ok=0;		//Niestety alarmowanie nie doszo do skutku
											//wyczam alarm 
							alarm_akt=0;	
			
							WriteTextXY(0,0,"   CENTRALA     ");	
 	 						WriteTextXY(0,1,"   ALARMOWA     ");
						
							return;
								
						};
				WriteTextXY(0,0,"  !!! ALARM !!! ");	
 	 			WriteTextXY(0,1,"                ");
				opis_alarmu(alarma);			
				delay(2000);
				
								
				alarm_ok=1;
				return;
				}
			alarma = PINF;
				
 	 		drzwi();		// sprawdzenie drzwi wejciowych
			
			
				if (end_awaryjny==0)
						{
							end_awaryjny=1;
							alarm_ok=0;		//Niestety alarmowanie nie doszo do skutku
											//wyczam alarm 
							alarm_akt=0;	
							
							WriteTextXY(0,0,"   CENTRALA     ");	
 	 						WriteTextXY(0,1,"   ALARMOWA     ");
						
							return;
								
						};
			
			WriteTextXY(0,0,"  !!! ALARM !!! ");
			WriteTextXY(0,1,"                ");
			opis_alarmu(alarma);
			delay(2000);
			alarm_ok=1;
			return;
			};
		};


	return;
	}

//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$44
//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$44
void abwera(void)
	{
	
		if(alarm_ok == 1)
			{
	    	
			typ_al=alarmowanie_a(0,100);
			
			if(typ_al == 1)	//telefon nr 1 :eeprom=0
									//access_code :eeprom=100
				{
				alarm_ok=0;	
				return;
				};

			typ_al=alarmowanie_a(16,104);
		
			if(typ_al==1)	//telefon nr 2 :eeprom=16
									//access_code :eeprom=104
				{
				alarm_ok=0;	
				return;
				};

			typ_al=alarmowanie_a(32,108);
		
			if(typ_al==1)	//telefon nr 3 :eeprom=32
									//access_code :eeprom=108
				{
				alarm_ok=0;	
				return;
				};

			typ_al=alarmowanie_a(48,112);
		
			if(typ_al==1)	//telefon nr 2 :eeprom=16
									//access_code :eeprom=112
				{
				alarm_ok=0;	
				return;
				};
		
			typ_al=alarmowanie_a(64,120);
			
			if(typ_al == 1)	//telefon nr 1 :eeprom=0
									//access_code :eeprom=100
				{
				alarm_ok=0;	
				return;
				};





			alarm_ok=0;		//Niestety alarmowanie nie doszo do skutku
							//wyczam alarm 
			alarm_akt=0;	
			
			WriteTextXY(0,0,"NIE ZGLOSZONO   ");
			WriteTextXY(0,1,"                ");
			opis_alarmu(opis);



			};					



	return;
	}



//3################################################################
void drzwi(void)
	{
		opis=alarma;
	
	
		if (opis == 0B11111110) 	
			{
			end_awaryjny=alarmowanie2();
			if (end_awaryjny==0) 	// alarm wywoany od drzwi wejsciowych
					{				// opunienie daje moliwo wyczenia alarmu
					opis=alarma;
					return;			
					}							
			
			};	 	

	return;
	}











void opis_alarmu(char alarma)
	{
		opis=alarma;
		opis = opis & 0b00000001;
		GotoXY(0,1);								//ustawienie pozycji kursora
		if (opis == 0) 	
			{
			LcdWrite('1');
			}
			else
			{
			LcdWrite('0');
			};	 


		opis=alarma;
		opis = opis & 0b00000010;
		GotoXY(1,1);								//ustawienie pozycji kursora
		if (opis == 0) 	
			{
			LcdWrite('1'); 
			}
			else
			{
			LcdWrite('0');
			};	 

		opis=alarma;
		opis = opis & 0b00000100;
		GotoXY(2,1);								//ustawienie pozycji kursora
		if (opis == 0) 	
			{
			LcdWrite('1'); 
			}
			else
			{
			LcdWrite('0');
			};	 


		opis=alarma;
		opis = opis & 0b00001000;
		GotoXY(3,1);								//ustawienie pozycji kursora
		if (opis == 0) 	
			{
			LcdWrite('1'); 
			}
			else
			{
			LcdWrite('0');
			};


		opis=alarma;
		opis = opis & 0b00010000;
		GotoXY(4,1);								//ustawienie pozycji kursora
		if (opis == 0) 	
			{
			LcdWrite('1'); 
			}
			else
			{
			LcdWrite('0');
			};	 


		opis=alarma;
		opis = opis & 0b00100000;
		GotoXY(5,1);								//ustawienie pozycji kursora
		if (opis == 0) 	
			{
			LcdWrite('1'); 
			}
			else
			{
			LcdWrite('0');
			};	 

		opis=alarma;
		opis = opis & 0b01000000;
		GotoXY(6,1);								//ustawienie pozycji kursora
		if (opis == 0) 	
			{
			LcdWrite('1'); 
			}
			else
			{
			LcdWrite('0');
			};	 


		opis=alarma;
		opis = opis & 0b10000000;
		GotoXY(7,1);								//ustawienie pozycji kursora
		if (opis == 0) 	
			{
			LcdWrite('1'); 
			}
			else
			{
			LcdWrite('0');
			};	 


		DDRC = 0b11111110;
		dane = PINC;
		dane = dane & 0b00000001;
		GotoXY(8,1);
		if (dane == 0b00000001) 
			{
			LcdWrite('0');	
		//	DebugSendString_P(PSTR("Zasilanie sprawne")); nadaj(10); nadaj(13);
			}
			else
			{
			LcdWrite('1'); 
			};


	opis=alarma;
	return;
	}
