/*
	 		Biblioteka LCD 2x16 AVR transmisja 4-bitowa
			Radowski Marcin
			06.01.2006r
*/

#include <stdlib.h>

#define LCD PORTA
#define SET_E PORTA |= _BV(5);   //sbi (PORTD,3)	// 1 PORTD |= _BV(3);
#define CLR_E PORTA &= ~_BV(5);  //cbi (PORTD,3)	// 0 PORTD &= ~_BV(3);
#define SET_RW PORTA |= _BV(7);  //sbi (PORTD,1)    // PORTD |= _BV(1);
#define CLR_RW PORTA &= ~_BV(7); //cbi (PORTD,1)    // PORTD &= ~_BV(1);
#define SET_RS PORTA |= _BV(4);  //sbi (PORTD,2)    // PORTD |= _BV(2);
#define CLR_RS PORTA &= ~_BV(4); //cbi (PORTD,2)    // PORTD &= ~_BV(2);
#define SET_LIGHT PORTA |= _BV(6);  //sbi (PORTD,1)    // PORTD |= _BV(1);
#define CLR_LIGHT PORTA &= ~_BV(6); //cbi (PORTD,1)    // PORTD &= ~_BV(1);

unsigned char i,q,x;
 


void E_p();
void WriteText(char *S);
int BcdWyswietl4 (unsigned int z1);
int BcdWyswietl2 (unsigned char z1);
int BcdWyswietl (char z,char u);
int BcdWyswietl1 (unsigned char z1);
void WriteTextXY(unsigned char x,unsigned char y, char *S);
void GotoXY(unsigned char x, unsigned char y);
void LCD_init (void);
void WriteByteToLcd(unsigned char z);
void WriteToLcdCtrlRegister(unsigned char z);
void LcdClrScr(void);



void E_p()		//Impuls strobujcy 
{
	SET_E;
	asm("nop");
	asm("nop");
	asm("nop");
	CLR_E;
}




void WriteByteToLcd(unsigned char z) //Wynik na 4 modszych bitach
{						
	LCD = ((LCD & 0xF0) | ((z & 0xF0) >> 4));
	//delay(2);
	asm("nop");
	asm("nop");
	asm("nop");
	E_p();
	LCD = ((LCD & 0xF0) | (z & 0x0F));
	//delay(2);
	E_p();
	delay(2);
	asm("nop");
	asm("nop");
	asm("nop");
}




void WriteToLcdCtrlRegister(unsigned char z)
{
	CLR_RS;								// ustawienie sygnaw sterujcych
	CLR_RW;
	WriteByteToLcd(z);
}

// zapis bajtu do pamieci wyswietlacza
void LcdWrite(unsigned char z)
{
	SET_RS;								// ustawienie sygnaw sterujcych
	CLR_RW;
	WriteByteToLcd(z);
}

//czyszczenie ekranu LCD
void LcdClrScr(void)
{
	WriteToLcdCtrlRegister(0x01);
	asm("nop");
	asm("nop");
	asm("nop");
}

void LCD_init (void)
{

	delay(45);
	CLR_RS;CLR_RW;					// wyzerowanie linii LcdReg,LcdRead,LcdEnable

	for (i = 0; i<3; i++)
		{	
		    SET_E;
			LCD = ((LCD & 0xF0) | 0x03);
			//LCD = ((LCD & 0x0F) | 0X30);
			asm("nop");
			asm("nop");
			asm("nop");
			CLR_E;
			delay(5);
		}	

	SET_E;	
	LCD = (LCD & 0xF0) | 0x02;
	//LCD = ((LCD & 0x0F) | 0X30);
	asm("nop");
	asm("nop");
	asm("nop");
	CLR_E;
	delay(5);
	WriteToLcdCtrlRegister(0x28);		
	WriteToLcdCtrlRegister(0x08);
	WriteToLcdCtrlRegister(0x01);
	delay(2);
	WriteToLcdCtrlRegister(0x06);
	WriteToLcdCtrlRegister(0x0C);
}

// ustawia kursor na wsprzdnych x,y
void GotoXY(unsigned char x, unsigned char y)
{
	switch (y)								// obliczenie o ile naley zwikszy x w zalenoci od wartoci y 
	{
		case 0:
			x += 0x80;						// x = x + 0x80
			break;
		case 1:
			x += 0xC0;						// x = x + 0xC0
			break;
	}
	WriteToLcdCtrlRegister(x);
}


// wywietla tekst na wsprzdnych x, y
void WriteTextXY(unsigned char x,unsigned char y, char *S)
{
	while (*S)								// ptla dziaa dotd,a napotkany zostanie znak koca acuch (/0)
	{
		GotoXY(x, y);						// wyliczenie adresu dla znaku
		LcdWrite(*S);						// wywietlenie pojedynczego znaku
		x++; 									// nastpna pozycja x na ekranie
		S++;									// nastpna pozycja wskanika,tzn.nastpny znak napisu
		if (x > 19)							// jeli x>19 to nastpna linia
		{
			x = 0; 
			y++;
		}
	}
}


// wywietla tekst na wsprzdnych x, y
void WriteText(char *S)
{
	while (*S)								// ptla dziaa dotd,a napotkany zostanie znak koca acuch (/0)
	{
		LcdWrite(*S);						// wywietlenie pojedynczego znaku
		S++;
	}
}

int BcdWyswietl4 (unsigned int z1)
{

	x1 = x2 = x3 = x4 = 0;
	
	x1 = z1 & 0xF000;
	x1 = x1 >> 12;
	x1 = x1 + 0x30;
	
	x2 = z1 & 0x0F00;
	x2 = x2 >> 8;
	x2 = x2 + 0x30;	
	
	x3 = z1 & 0x00F0;
	x3 = x3 >> 4;
	x3 = x3 + 0x30;	 
	
	x4 = z1 & 0x000F;
	x4 = x4 + 0x30;	
	
	LcdWrite(x1);
	LcdWrite(x2);
	LcdWrite(x3);
	LcdWrite(x4);
return 0;
}

int BcdWyswietl2 (unsigned char z1)
{
	x3 = x4 = 0;
	x3 = z1 & 0xF0;
	x3 = x3 >> 4;
	x3 = x3 + 0x30;	 
	x4 = z1 & 0x0F;
	x4 = x4 + 0x30;	
	LcdWrite(x3);
	LcdWrite(x4);
return 0;
}

int BcdWyswietl (char z,char u)		// jesli u = 0 wyswietla z zerem na poczatku
{
	x2 = x1 = 0;
  	x2 = z & 0xF0;
  	x2 = x2 >> 4;	
  	x2 = x2 + 0x30;						// uzupelnienie do kodu ASCI
switch (u)
	{
	case 1:									// alternatywne wyswietlanie
		if (x2 == 0x30){x2 = 0x20;}			// jesli zero spacja
		break;
	}
x1 = z & 0x0F;
x1 = x1 + 0x30;
LcdWrite(x2);
LcdWrite(x1);	
return 0;	
}

int BcdWyswietl1 (unsigned char z1)
{
	x1 = 0;
	x1 = z1 & 0x0F;
	x1 = x1 + 0x30;	
	LcdWrite(x1);
	return 0;
}

